/*
 * oscp-adev.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <unistd.h> //usleep
#include <string.h> //strcpy

//    #include <sys/types.h>
//       #include <sys/stat.h>
       #include <fcntl.h>


#ifdef FFTW
//int soxinited=-77; sox_effects_chain_t * chain; sox_effect_t * e; char * vol[] = {"3dB"};
#include <fftw3.h>
fftw_complex *fftw_in, *fftw_out; fftw_plan fftw_p;
int fftw_n=-77;
#endif


static float flt_max;

#ifdef LAO
#include <ao/ao.h>
int aodriver=-1; ao_device *aodevice; ao_sample_format sformat;
#else
struct sample_format_s { int bits; int channels; int rate; };
struct sample_format_s sformat;

#include "soundcard.h"
#include <sys/ioctl.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


// #define SNDCTL_DSP_SETFMT               _SIOWR('P',5, int) /* Selects ONE fmt*/
// #       define AFMT_QUERY               0x00000000      /* Return current fmt */
// #       define AFMT_MU_LAW              0x00000001
// #       define AFMT_A_LAW               0x00000002
// #       define AFMT_IMA_ADPCM           0x00000004
// #       define AFMT_U8                  0x00000008
// #       define AFMT_S16_LE              0x00000010      /* Little endian signed 16*/
// #       define AFMT_S16_BE              0x00000020      /* Big endian signed 16 */
// #       define AFMT_S8                  0x00000040
// #       define AFMT_U16_LE              0x00000080      /* Little endian U16 */
// #       define AFMT_U16_BE              0x00000100      /* Big endian U16 */
// #       define AFMT_MPEG                0x00000200      /* MPEG (2) audio */
// #       define AFMT_AC3         0x00000400   
// */

int afd=-1;

float dts(struct timespec ts, struct timespec ts0);
void gts(struct timespec *tss);
struct timespec ats0,ats1; int awt=0;
#endif


extern int vis;
/*
# include <linux/limits.h> // PATH_MAX
# define PM PATH_MAX
struct conf_s {
 int conf_ver,debug,quit,paused, lines,cols, lw,lh, lineart, offs, fullpath, vis,
  shuffle, repeat, eias, autoplay, autoalpha, timeremaining_mode, style[13];
 int lastpos; char wd[PM], file[PM], udir[10][PM], favsavepath[PM], mplayer_path[PM];
} conf;
*/

void lf(char *a);
void lfd(char *a, int b);
void dlog(int l, char *msg);
void cs(char *a);
//int parent_ear, parent_said;
//void fdreadline(int fd, char *b, int n);

void d(int l, char *msg);


int mixer=0, mixer_channel, volume=-1;
#ifdef CYGWIN
void mixer_end() {}
int get_volume() { return -1; }
void set_volume() {}
void chvol(int ch) {}
void mixer_init() {}
#else
#include <linux/soundcard.h>
#include <sys/ioctl.h>
/////###########
void mixer_end() { lf("mixer_end"); if(mixer>0) close(mixer); mixer=0; }
////############
int get_volume() { lf("get_volume");
 if(mixer<=0) return -1; int vl, vr, s; ioctl(mixer, MIXER_READ(mixer_channel), &s);
 vl=(s & 0x000000FF); vr=((s & 0x0000FF00)>>8); volume=((vl+vr)/2); return volume; }
/////####################
void set_volume(int pvol) { lfd("set_volume",pvol);
 if(mixer<=0) return; int s=(pvol<<8)+pvol;
 ioctl(mixer, MIXER_WRITE(mixer_channel), &s); get_volume(); }
/////#############
void chvol(int ch) { lfd("chvol",ch); if(mixer<=0) return; int s=ch+get_volume();
 if(s<0) s=0; else if(s>100) s=100; set_volume(s); }
#include <sys/types.h> // open
#include <sys/stat.h>
/////############
void mixer_init() { lf("mixer_init"); if((mixer=open("/dev/mixer", O_RDWR))<=0) return;
 mixer_channel=SOUND_MIXER_PCM; get_volume();
 if(volume<0) { mixer_channel=SOUND_MIXER_VOLUME; get_volume(); }
 if(volume<0) { mixer_end(); d(0, "mixer unavailable"); }
}
#endif




#define audio_outbuf_size 48000*4
//static 
signed short audio_outbuf[audio_outbuf_size];

/////############
void adev_close() { lfd("adev_close: aodevice", (aodevice?1:0));
#ifdef LAO
 if(aodevice) { ao_close(aodevice); aodevice=NULL; }
//ao_close(aodevice);
#endif
}
/////#########################################
void adev_setp(int bits, int *chan, int *rate) { lf("adev_setp"); flt_max=0.0;
 char lmsg[1024]; sprintf(lmsg, "adev_setp: b:%d, ch:%d, r:%d", bits, *chan, *rate); dlog(9,lmsg);

#ifdef LAO
 sformat.bits=16;
lf("adev_setp:adev_close");
 adev_close();
lf("adev_setp:ao_open_live");
 aodevice=ao_open_live(aodriver,&sformat, &(ao_option){.key="buffer_time", .value="500"});
lfd("adev_setp:bits", bits);
 sformat.bits=bits;
#else
 static char lmsg[128]; lmsg[127]=0; int status, arg;
 arg=bits; status=ioctl(afd, SOUND_PCM_WRITE_BITS, &arg);
 if(status == -1) dlog(9, "SOUND_PCM_WRITE_BITS ioctl failed");
 if(arg!=bits) dlog(9, "unable to set sample size");
 else { sprintf(lmsg, "sample set to: %d", arg); dlog(9, lmsg); }

 arg=*chan; status=ioctl(afd, SOUND_PCM_WRITE_CHANNELS, &arg);
 if(status==-1) dlog(9, "SOUND_PCM_WRITE_CHANNELS ioctl failed");
 if(arg!=*chan) dlog(9, "unable to set number of channels");
 else { sprintf(lmsg, "chans set to: %d", arg); dlog(9, lmsg); }

 arg=*rate; status=ioctl(afd, SOUND_PCM_WRITE_RATE, &arg);
 if(status==-1) dlog(9, "SOUND_PCM_WRITE_WRITE ioctl failed");
 if(arg!=*rate) dlog(9, "unable to set sample rate");
 else { sprintf(lmsg, "rate set to: %d", arg); dlog(9, lmsg); }
#endif
}
////###########
int adev_init() { lf("adev_init");
#ifdef LAO
 if(aodriver==-1) {
  ao_initialize(); aodriver=ao_default_driver_id(); }
 if(aodriver==-1) {
  char lmsg[1024]; sprintf(lmsg, "Info: aodriver: %d\n", aodriver); cs(lmsg);
  return 0;
 }
#else
 if(afd<0) afd=open("/dev/dsp", O_WRONLY);
 if(afd<0) { dlog(9,"Error: open of /dev/dsp failed"); return -1; }
#endif
 return 1;
}

/////##########
void adev_end() { lf("adev_end");
 flt_max=0;
#ifdef LAO
 adev_close(); ao_shutdown(); aodriver=-1;
#else
 if(afd>0) close(afd); 
#endif

#ifdef FFTW
 fftw_destroy_plan(fftw_p); fftw_free(fftw_in); fftw_free(fftw_out);
#endif
}



#if 1
#include "libavutil/samplefmt.h"
#else
enum AVSampleFormat { AV_SAMPLE_FMT_NONE = -1, AV_SAMPLE_FMT_U8, AV_SAMPLE_FMT_S16,
 AV_SAMPLE_FMT_S32, AV_SAMPLE_FMT_FLT, AV_SAMPLE_FMT_DBL, AV_SAMPLE_FMT_U8P, AV_SAMPLE_FMT_S16P,
 AV_SAMPLE_FMT_S32P, AV_SAMPLE_FMT_FLTP, AV_SAMPLE_FMT_DBLP, AV_SAMPLE_FMT_NB };
#endif

#define opc 40/1
int64_t opl[opc], opr[opc], opi=0;

struct timespec apts0, apts1;
float gts(struct timespec *tss);
float dts(struct timespec ts, struct timespec ts0);

/////#############################
void adev_visprep(int cnt, int ch) {
#if 1
 int i,j; int64_t pl=0, pr=0; int16_t *b2=audio_outbuf; static char lmsg[1024]; lmsg[1023]=0;

 if(ch==2) { for(i=0;i<cnt;i+=2) {
//  pl+=b2[i]*b2[i]/32768; pr+=b2[i+1]*b2[i+1]/32768;
  pl+=b2[i]*b2[i]/32768; pr+=b2[i+1]*b2[i+1]/32768;
 } }
 else if(ch==1) { for(i=0;i<cnt;i++) { pl+=b2[i]; } pr=pl; }

 opl[opi]=pl; pl=0; opr[opi]=pr; pr=0;  opi++; if(opi>=opc) opi=0;  pl=opl[opi]; pr=opr[opi];
// for(i=0; i<opc; i++) { pl+=opl[i]; pr+=opl[i]; }

 gts(&apts1); float dt=dts(apts1, apts0); if(dt>=0.05) // 20fps
 { memcpy(&apts0, &apts1, sizeof(struct timespec));
#if 0
  snprintf(lmsg, 1023, "VU: pl:%10Ld pr:%10Ld\n", pl/cnt/ch, pr/cnt/ch);
#else
  int ps,po;
//  sprintf(lmsg, "VU: %8Ld,%8Ld ", pl, pr); po=22;
  sprintf(lmsg, "VU:  "); po=4;

  ps=24; memset(lmsg+po, *" ", po+ps*2); lmsg[po+ps]=*"#";
  j=100000; for(i=1;i<=ps;i++) { j*=1.2;
   if(pl>j) lmsg[po+ps-i]=*"="; else lmsg[po+ps-i]=*" ";
   if(pr>j) lmsg[po+ps+i]=*"="; else lmsg[po+ps+i]=*" ";
  } lmsg[po+ps*2]=*"\n"; lmsg[po+ps*2+1]=0;
#endif
  cs(lmsg);
 }
#endif
}


//enum AVSampleFormat { AV_SAMPLE_FMT_NONE = -1, AV_SAMPLE_FMT_U8, AV_SAMPLE_FMT_S16,
// AV_SAMPLE_FMT_S32, AV_SAMPLE_FMT_FLT, AV_SAMPLE_FMT_DBL, AV_SAMPLE_FMT_U8P, AV_SAMPLE_FMT_S16P,
// AV_SAMPLE_FMT_S32P, AV_SAMPLE_FMT_FLTP, AV_SAMPLE_FMT_DBLP, AV_SAMPLE_FMT_NB };

int last_cnt=0;
////#######################################################
int adev_conv(void *smpl_buf, int cnt, int chans, int sfmt) { lf("adev_conv");
 static char lmsg[1024];
 static int32_t **p32;
 static int16_t **p16;
 static float **pf; static uint8_t **u8;
 int newm=0; static float fltm=0.0;
 int write_p=0, nb=0, ch; static char lfmt[16];

if(0||last_cnt!=cnt) { last_cnt=cnt;
 sprintf(lmsg, "adev_conv: cnt:%d, ch:%d, sfmt: %d", cnt, chans, sfmt); dlog(9,lmsg);
}

 switch(sfmt) {
  case AV_SAMPLE_FMT_S32P: strcpy(lfmt, "s32p"); p32=(int32_t **)smpl_buf;
   for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
   { audio_outbuf[write_p]=p32[ch][nb]>>16; write_p++; } }
   break;

  case AV_SAMPLE_FMT_S16P: strcpy(lfmt, "s16p"); p16=(int16_t **)smpl_buf;
   for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
   { audio_outbuf[write_p]=p16[ch][nb]; write_p++; } }
   break;

  case AV_SAMPLE_FMT_S16: strcpy(lfmt, "s16"); p16=(int16_t **)smpl_buf;
#if 1
//dlog(9,"DING");
   memcpy(audio_outbuf, p16[0], cnt*2*chans);
   nb=cnt;
#else
   if(chans==1) { for(nb=0;nb<cnt;nb++){ audio_outbuf[write_p] = p16[0][nb]; write_p++; }}
   else if(chans==2) { for(nb=0;nb<cnt;nb+=2){
    audio_outbuf[write_p] = p16[0][nb];
    audio_outbuf[write_p+1] = p16[0][nb+1];
    write_p+=2;
   }} else { nb=0; cs("Info: how many channels?!\n"); }
#endif
   break;

  case AV_SAMPLE_FMT_U8P: strcpy(lfmt, "u8p"); u8=(uint8_t **)smpl_buf;
   for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
   { audio_outbuf[write_p]=(u8[ch][nb]-128)*255; write_p++; } }
   break;

  case AV_SAMPLE_FMT_U8: strcpy(lfmt, "u8"); u8=(uint8_t **)smpl_buf;
   for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
   { audio_outbuf[write_p]=(u8[0][nb*chans+ch]-128)*255; write_p++; } }
   break;

  case AV_SAMPLE_FMT_FLTP: strcpy(lfmt, "fltp"); pf=(float **)smpl_buf;
   for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
   {
    //audio_outbuf[write_p] = (short)( 32767.0*((float *) ffmframe->extended_data[ch])[nb]);
    fltm=pf[ch][nb];
    if(fltm>flt_max) { newm++; flt_max=fltm; } else if(fltm<-flt_max) { newm++; flt_max=-fltm; }
    if(flt_max>1.0) fltm/=flt_max; //if(fltm>1.0) fltm=1.0; else if(fltm<-1.0) fltm=1.0;
    audio_outbuf[write_p] = 32767.0*fltm; write_p++;
   } }

   if(newm!=0 && flt_max>1.0) { write_p=0;
    sprintf(lmsg, "Info: new max fltp: %f (%d)\n", flt_max, newm); cs(lmsg);
    for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
    { audio_outbuf[write_p]=pf[ch][nb]*32767.0/flt_max; write_p++; }}
   }
   break;

  case AV_SAMPLE_FMT_FLT: strcpy(lfmt, "flt"); pf=(float **)smpl_buf;
   for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
   {
    //audio_outbuf[write_p] = (short)( 32767.0*((float *) ffmframe->extended_data[ch])[nb]);
    fltm=pf[0][nb*chans+ch];
    if(fltm>flt_max) { newm++; flt_max=fltm; } else if(fltm<-flt_max) { newm++; flt_max=-fltm; }
    if(flt_max>1.0) fltm/=flt_max; //if(fltm>1.0) fltm=1.0; else if(fltm<-1.0) fltm=1.0;
    audio_outbuf[write_p] = 32767.0*fltm; write_p++;
   } }

   if(newm!=0 && flt_max>1.0) { write_p=0;
    sprintf(lmsg, "Info: new max flt: %.2f (%d)\n", flt_max, newm); cs(lmsg);
    for(nb=0;nb<cnt;nb++){ for(ch=0; ch<chans; ch++)
    { audio_outbuf[write_p]=pf[0][nb*chans+ch]*32767.0/flt_max; write_p++; }}
   }
   break;

  default: strcpy(lfmt, "UNSU");
   sprintf(lmsg, "Info: fmt:%s (%d), ch:%d, bi:%d, ra:%d, cnt: %d\n",
    lfmt, sfmt, sformat.channels, sformat.bits, sformat.rate, cnt); cs(lmsg);
   return 0;
 }
 if(vis>0) adev_visprep(cnt, sformat.channels);
 return nb;
}

#ifdef FFTW
 fftw_plan fftw_p0, fftw_p1;
 double *fftw_inR; fftw_complex *fftw_outC;
#endif

////###################################################
int adev_out(void *smpl_buf, int cnt, int ch, int sfmt) { lf("adev_write"); int ret;

 ret=adev_conv(smpl_buf, cnt, ch, sfmt); if(ret<=0) return ret;

#ifdef FFTW
// http://www.zytrax.com/tech/audio/equalization.html
// http://blog.bjornroche.com/2012/08/basic-audio-eqs.html
 if(fftw_n!=ret) { fftw_n=cnt;
  fftw_free(fftw_in); fftw_free(fftw_out);
#if 0
  fftw_in = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * fftw_n);
  fftw_out = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * fftw_n);
  fftw_p = fftw_plan_dft_1d(fftw_n, fftw_in, fftw_out, FFTW_FORWARD, FFTW_ESTIMATE);
#else
  fftw_in = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * fftw_n);
  fftw_out = (fftw_complex*) fftw_malloc(sizeof(fftw_complex) * fftw_n);
  fftw_p0=fftw_plan_dft_r2c_1d(fftw_n, double *in, fftw_complex *out,
                                    unsigned flags);
  fftw_p1=fftw_plan_dft_c2r_1d(fftw_n, fftw_complex *in, double *out,
                                    unsigned flags);
#endif
 }
 int ci, i;
 for(ci=0; ci<ch; ci++) {
  for(i=0; i<cnt; i++) { fftw_in[i][0]=audio_buf[i*ch+ci]; fftw_in[i][1]=0; }
  fftw_execute(fftw_p);
 }
#endif

#ifdef LAO
 if(ao_play(aodevice, (char *)audio_outbuf, cnt*2*ch)==0) { adev_close(); ret=1; }
#else
 if(afd>0) { int dt; char lmsg[1024]; gts(&ats1); dt=1000000.0*dts(ats1, ats0);
  sprintf(lmsg, "dt: %d, awt: %d, awt-dt: %d, cnt: %d, ch: %d, rate: %d",
   dt, awt, awt-dt, cnt, ch, sformat.rate); dlog(9, lmsg);
  if(awt-dt-10000>0) usleep((awt-dt)-10000);  ret=write(afd, smpl_buf, cnt*2*ch);
  gts(&ats0); awt=1000000*cnt/sformat.rate;
 }
#endif

// adev_visprep(cnt, ch);

 return ret;
}
